#!/usr/bin/perl

# Converts 0.1.x .idata file to current .idata format

$home_dir = $ENV{"HOME"}."/";

# saves old data file as ~/.idata.bak

print "Backing up old data file...\n";

system "mv $home_dir.idata $home_dir.idata.bak"
    || die "Couldn't back up old data file!";

print "Reading in old data file...\n";

# opens old data file and reads all the info in

$data_file = $home_dir.".idata.bak";

open(DATA, "< $data_file")
    || die "Couldn't read old data file! ($data_file)";

$line = <DATA>;

while ($line =~ s/(\w+)\s+//) 
{
    $tv[$#tv+1] = $1;
}

$line = <DATA>;
$i=1;

while ($line =~ s/(\d+)\s+//) 
{
    $n{$tv[$i++]} = $1;
}

$word[0] = "";

while (($line = <DATA>) && (!($line =~ m/^\s*$/)))  
{
    $line =~ s/^(\w+)\s+//;
    $word[$#word+1] = $1;
    $index{$1} = $#word;
    
    $tv_index = 1;
    
    while ($line =~ s/(\d+)\s+//) 
    {
	$nk{$word[$#word].",".$tv[$tv_index]} = $1;
	$tv_index++;
    }
}

print "Writing new data file...\n";

# reopen the data file and write the old info in the new format :)

open(DATA, "> $home_dir.idata") || die "Couldn't open data file\n";

# prints category names to data file
foreach $i (1..$#tv)
{
    print DATA $tv[$i]." ";
}
print DATA "\n";

# prints total word frequency values
for ($i=1; $i <= $#tv; $i++) 
{
    if ($n{$tv[$i]} > 0) {
	print DATA $n{$tv[$i]}." ";
    } else {
	print DATA "0 ";
    }
}
print DATA "\n";

# prints number of documents for each category
for ($i=1; $i <= $#tv; $i++) 
{
    print DATA "0 ";
}
print DATA "\n";

for ($i=1; $i <= $#word; $i++) 
{
    print DATA $word[$i]." 1 ";
    
    for ($j=1; $j <= $#tv; $j++) {
	if ($nk{$word[$i].",".$tv[$j]} > 0) {
	    print DATA $j.":".$nk{$word[$i].",".$tv[$j]}." ";
	}
    }
    print DATA "\n";
}

close(DATA);

print "Done!\n";




